#define DEBUG
// Radar Demo v2 (25/06/04)  - By Malver
//
// I created this demo using some code from one of my recent games, "Bizlof War: Tactical
// Implications".
//
// I created this demo to inspire all of you to make some nifty games using radar, as well as
// teach some of you unenlightened folk about the joys of the recent DrawBox() function :)
//
// Here's what kind of code bits I've included in this demo:
//
// - Radar appearance via a HUD
// - A few mobs of different teams, to illustrate showing different teams on the radar
//
// If you'd like to see anything else included with this, or want to report some nasty
// bugs, then drop me a line at 'malver032@hotmail.com', or contact me on AIM (Veley032)
//
// Enjoy! :)

client
	var
		obj/radar  // The client's radar object (handy because we get reference to it later!)

turf
	icon = 'Turfs.dmi'
	Grass/icon_state = "Grass"
	Water/icon_state = "Water"
	Hole
		icon_state = "Hole"
		Enter(mob/M)
			M.loc = src
			if(ismob(M))
				M.z--
	Ladder
		icon_state = "Ladder"
		Enter(mob/M)
			M.loc = src
			if(ismob(M))
				M.z++
mob
	icon = 'Chars.dmi'
	icon_state = "Red"
	var
		team  // The colour that the blip will be when shown on the radar
	NPC
		Blue
			team = rgb(0,0,255)  // Blue
			icon_state = "Blue"
		Red
			team = rgb(255,0,0)  // Red
			icon_state = "Red"
		New()
			..()
			WalkAround()  // Call simple AI

world/New()
	..()
	Update_Radar() // Initate the radar loop

client/New()
	var/obj/O = new   // This code creates the radar object and places it on the client's screen. Note how the object 'follows' the mob around as he moves. This is because the object is 'attached' to the client screen.
	O.icon = icon('Radar_Blips.dmi',"Radar")
	O.screen_loc = "NORTH,EAST"  // Place the radar at the top-right corner of the screen
	O.layer = 50  // Set it to a high layer so nothing appears over it
	src.screen += O
	src.radar = O
	..()

proc/Update_Radar()
	for(var/client/C)  // Loop through all non-npc players...
		if(C.radar)
			var/icon/R = icon('Radar_Blips.dmi',"Radar")  // Create an icon to draw on
			R.DrawBox(rgb(0,128,0),0,0,32,32)  // Clear the radar icon with a dark-ish green
			R.DrawBox(rgb(255,255,255), 17, 17-3, 17, 17+3)
			R.DrawBox(rgb(255,255,255), 17-3, 17, 17+3, 17)
			for(var/mob/M in world)  // Search through all of the mobs...
				if(get_dist(C.mob,M) < 20 && C.mob.z == M.z && C.mob != M)  // If the mob is within 10 squares of the player, is on the same z level, and isn't itself (don't want to place yourself on it, do you?)
					var/x = 16-(C.mob.x - M.x)+1
					var/y = 16-(C.mob.y - M.y)+1
					R.DrawBox(M.team, x-1, y-1, x+1, y+1)  // Draw the blip at the proper x/y coordinates
			C.radar.icon = R  // Set the new icon onto the radar
	spawn(5)
		Update_Radar()  // Refresh the radar every 1/2 second  (feel free to play with the update speed!)


mob/proc/WalkAround()  // Simple AI for moving the mob to make things more interesting!
	step(src, pick(NORTH,SOUTH,EAST,WEST))
	spawn(rand(5,15))
		WalkAround()